Bug 1761907 - Rebalance causing IO Error - File descriptor in bad state
Summary: Rebalance causing IO Error - File descriptor in bad state
Keywords:
Status: CLOSED NEXTRELEASE
Alias: None
Product: GlusterFS
Classification: Community
Component: distribute
Version: 6
Hardware: Unspecified
OS: Unspecified
unspecified
high
Target Milestone: ---
Assignee: Mohit Agrawal
QA Contact:
URL:
Whiteboard:
Depends On: 1758432
Blocks: 1696809 1758579 1761910 1806996
TreeView+ depends on / blocked
 
Reported: 2019-10-15 14:36 UTC by Mohit Agrawal
Modified: 2020-02-25 12:28 UTC (History)
9 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of: 1758432
Environment:
Last Closed: 2019-10-17 10:55:46 UTC
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Gluster.org Gerrit 23552 None Merged dht: Rebalance causing IO Error - File descriptor in bad state 2019-10-17 10:55:45 UTC

Comment 1 Mohit Agrawal 2019-10-15 14:37:29 UTC
Hi,

Steps to reproduce 

1.Mounted a disperse volume
2.Started the a python script from 2 clients (one from /mnt/EC and another from /mnt/EC/dir1) to continues
  fd open/close in multiple threads
3.Added brick and started rebalance 
4.Rebalance has completed
5. Python script is getting failure "File descriptor in bad state" 

RCA:
Before merged this patch https://review.gluster.org/#/c/glusterfs/+/15804/ if fd 
is not opened client_fops sets anon fd without checking fd is anonymous or not so there was no issue 
in if fd is not opened before throwing any fop but after merged this patch CLIENT_GET_REMOTE_FD sets the errno to EBADFD if fd is not anonymous.In dht fop_cbks code path open fd only while errno is EBADF so need to handle EBADFD if any dht children xlator sets as an error if fd is not opened.

A patch is posted on upstream
https://review.gluster.org/#/c/glusterfs/+/23518/

Regards,
Mohit Agrawal

Comment 2 Worker Ant 2019-10-15 15:02:22 UTC
REVIEW: https://review.gluster.org/23552 (dht: Rebalance causing IO Error - File descriptor in bad state) posted (#1) for review on release-6 by MOHIT AGRAWAL

Comment 3 Worker Ant 2019-10-17 10:55:46 UTC
REVIEW: https://review.gluster.org/23552 (dht: Rebalance causing IO Error - File descriptor in bad state) merged (#2) on release-6 by hari gowtham


Note You need to log in before you can comment on or make changes to this bug.